/* 
 * OnlineUserRecorder.cs @Microsoft Visual Studio 2008 <.NET Framework 2.0 (or Higher)>
 * AfritXia
 * 2008-03-06
 * 
 * Copyright(c) http://www.AfritXia.NET/
 * 
 */

using System;
using System.Collections.Generic;
using System.Threading;

namespace App.Core.OnlineStat
{
	/// <summary>
	/// û¼
	/// </summary>
    public class OnlineUserRecorder
    {
        // ûݿ
        private OnlineUserDB m_db = null;
        //  A, ڽ
        private Queue<OnlineUserCmdBase> m_cmdQueueA = null;
        //  X, ִ
        private Queue<OnlineUserCmdBase> m_cmdQueueX = null;
        // æ־
        private bool m_isBusy = false;
        // ϴͳʱ
        private DateTime m_lastStatisticTime = new DateTime(0);
        // ûʱ
        private int m_userTimeOutMinute = 20;
        // ͳʱ
        private int m_statisticEventInterval = 60;

        #region ๹
        /// <summary>
        /// ĬϹ
        /// </summary>
        internal OnlineUserRecorder()
        {
            this.m_db = new OnlineUserDB();

            // ʼ
            this.m_cmdQueueA = new Queue<OnlineUserCmdBase>();
            this.m_cmdQueueX = new Queue<OnlineUserCmdBase>();
        }
        #endregion

        /// <summary>
        /// ûȡûʱ
        /// </summary>
        internal int UserTimeOutMinute
        {
            set
            {
                this.m_userTimeOutMinute = value;
            }

            get
            {
                return this.m_userTimeOutMinute;
            }
        }

        /// <summary>
        /// ûȡͳʱ(λ)
        /// </summary>
        internal int StatisticEventInterval
        {
            set
            {
                this.m_statisticEventInterval = value;
            }

            get
            {
                return this.m_statisticEventInterval;
            }
        }

        /// <summary>
        /// ûϢ
        /// </summary>
        /// <param name="onlineUser"></param>
        public void Persist(OnlineUser onlineUser)
        {
            // ɾ
            OnlineUserDeleteCmd delCmd = new OnlineUserDeleteCmd(this.m_db, onlineUser);
            // 
            OnlineUserInsertCmd insCmd = new OnlineUserInsertCmd(this.m_db, onlineUser);

            // ӵ
            this.m_cmdQueueA.Enqueue(delCmd);
            this.m_cmdQueueA.Enqueue(insCmd);

            // 
            this.BeginProcessCmdQueue();
        }

        /// <summary>
        /// ɾûϢ
        /// </summary>
        /// <param name="onlineUser"></param>
        public void Delete(OnlineUser onlineUser)
        {
            // ɾ
            OnlineUserDeleteCmd delCmd = new OnlineUserDeleteCmd(this.m_db, onlineUser);

            // ӵ
            this.m_cmdQueueA.Enqueue(delCmd);

            // 
            this.BeginProcessCmdQueue();
        }

        /// <summary>
        /// ȡûб
        /// </summary>
        /// <returns></returns>
        public IList<OnlineUser> GetUserList()
        {
            return this.m_db.Select();
        }

        /// <summary>
        /// ȡû
        /// </summary>
        /// <returns></returns>
        public int GetUserCount()
        {
            return this.m_db.Count();
        }

        /// <summary>
        /// 첽ʽ
        /// </summary>
        private void BeginProcessCmdQueue()
        {
            if (this.m_isBusy)
                return;

            // δͳƵʱ
            if (DateTime.Now - this.m_lastStatisticTime < TimeSpan.FromSeconds(this.StatisticEventInterval))
                return;

            Thread t = null;

            t = new Thread(new ThreadStart(this.ProcessCmdQueue));
            t.Start();
        }

        /// <summary>
        /// 
        /// </summary>
        private void ProcessCmdQueue()
        {
            lock (this)
            {
                if (this.m_isBusy)
                    return;

                // δͳƵʱ
                if (DateTime.Now - this.m_lastStatisticTime < TimeSpan.FromSeconds(this.StatisticEventInterval))
                    return;

                this.m_isBusy = true;

                // ʱ, ڽ
                Queue<OnlineUserCmdBase> tempQ = null;

                // 
                tempQ = this.m_cmdQueueA;
                this.m_cmdQueueA = this.m_cmdQueueX;
                this.m_cmdQueueX = tempQ;
                tempQ = null;

                while (this.m_cmdQueueX.Count > 0)
                {
                    // ȡ
                    OnlineUserCmdBase cmd = this.m_cmdQueueX.Peek();

                    if (cmd == null)
                        break;

                    // ִ
                    cmd.Execute();

                    // ӶƳ
                    this.m_cmdQueueX.Dequeue();
                }

				// ʱû
				this.m_db.ClearTimeOut(this.UserTimeOutMinute);
				// 
				this.m_db.Sort();

                this.m_lastStatisticTime = DateTime.Now;
                this.m_isBusy = false;
            }
        }
    }
}